Index: trunk/src/VBox/Installer/win/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/win/Makefile.kmk	(revision 106989)
+++ trunk/src/VBox/Installer/win/Makefile.kmk	(revision 106990)
@@ -205,9 +205,9 @@
 
 ifdef VBOX_WITH_COMBINED_PACKAGE
- PATH_MULTIARCH_TEMP                := $(PATH_OUT_BASE)/win.x86/$(KBUILD_TYPE)/obj/Installer
+ PATH_MULTIARCH_TEMP                := $(PATH_OUT_BASE)/win.amd64/$(KBUILD_TYPE)/obj/Installer
  PATH_MULTIARCH_GUEST_ADDITIONS_ISO := $(PATH_OUT_BASE)/win.amd64/$(KBUILD_TYPE)/bin/additions
  PACKAGE_NAME_MULTIARCH             := $(PACKAGE_NAME_LANG)-MultiArch
- PACKAGE_NAME_MULTIARCH.x86         := $(PACKAGE_NAME_MULTIARCH)_x86.msi
  PACKAGE_NAME_MULTIARCH.amd64       := $(PACKAGE_NAME_MULTIARCH)_amd64.msi
+ PACKAGE_NAME_MULTIARCH.arm64       := $(PACKAGE_NAME_MULTIARCH)_arm64.msi
  PACKAGE_NAME_FINAL                 := $(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.$(KBUILD_TARGET_ARCH))
  PACKAGE_NAME_MULTIARCH_FINAL       := $(PACKAGE_NAME_MULTIARCH).exe
@@ -219,5 +219,5 @@
  BLDDIRS += $(PATH_MULTIARCH_TEMP)
  PACKING += $(PACKAGE_NAME_FINAL)
- ifeq ($(KBUILD_TARGET_ARCH),x86)
+ ifeq ($(KBUILD_TARGET_ARCH),amd64)
   PACKING += $(PATH_STAGE_BIN)/$(PACKAGE_NAME_MULTIARCH_FINAL)
  endif
@@ -268,8 +268,8 @@
 
 ifdef VBOX_WITH_COMBINED_PACKAGE
- ifeq ($(KBUILD_TARGET_ARCH),x86)
+ ifeq ($(KBUILD_TARGET_ARCH),amd64)
   OTHER_CLEAN += \
   	$(VBOX_WIN_INST_REPACK_DIR)/3-multiarch-$(PACKAGE_NAME_MULTIARCH_FINAL).cmd \
-  	$(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.x86)
+  	$(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.amd64)
  endif
  ifndef VBOX_WITH_MSM_INSTALL
@@ -1133,15 +1133,15 @@
 
 
-if defined(VBOX_WITH_COMBINED_PACKAGE) && "$(KBUILD_TARGET_ARCH)" == "x86"
+if defined(VBOX_WITH_COMBINED_PACKAGE) && "$(KBUILD_TARGET_ARCH)" == "amd64"
  #
  # Make the multi-architecture installer by calling our stub builder
- # with both platform installers (x86 and amd64) + common cab. The common
+ # with both platform installers (amd64 and arm64) + common cab. The common
  # cab only is needed when we don't use merge modules. We only
- # need to do this once; so do it on x86 only.
+ # need to do this once; so do it on amd64 only.
  #
  $(PATH_STAGE_BIN)/$(PACKAGE_NAME_MULTIARCH_FINAL) \
  + $(VBOX_WIN_INST_REPACK_DIR)/3-multiarch-$(PACKAGE_NAME_MULTIARCH_FINAL).cmd: \
- 		$(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.x86) \
  		$(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.amd64) \
+ 		$(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.arm64) \
  		$(PATH_STAGE_BIN)/VBoxStub.exe \
  		$$(VBoxStubBld_1_TARGET)
@@ -1153,6 +1153,6 @@
 	$(REDIRECT) -C $(@D) -- \
 		$(VBoxStubBld_1_TARGET) -out $@ \
-			-target-x86 $(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.x86) \
 			-target-amd64 $(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.amd64) \
+			-target-arm64 $(PATH_MULTIARCH_TEMP)/$(PACKAGE_NAME_MULTIARCH.arm64) \
 			$(if-expr defined(VBOX_WITH_MSM_INSTALL),,-target-all $(PACKAGE_NAME_MULTIARCH_COMMONCAB)) \
 			-stub $(PATH_STAGE_BIN)/VBoxStub.exe
@@ -1168,8 +1168,8 @@
 		'..\bin\VBoxStubBld.exe ^' \
 		'  -out $(@F) ^' \
-		'  -target-x86 $(PACKAGE_NAME_MULTIARCH.x86) ^' \
-		'  -target-amd64 ../../../win.amd64/$(KBUILD_TYPE)/repack/$(PACKAGE_NAME_MULTIARCH.amd64) ^' \
+		'  -target-amd64 $(PACKAGE_NAME_MULTIARCH.amd64) ^' \
+		'  -target-arm64 ../../../win.arm64/$(KBUILD_TYPE)/repack/$(PACKAGE_NAME_MULTIARCH.arm64) ^' \
 		$(if-expr defined(VBOX_WITH_MSM_INSTALL),\
-		,'  -target-all ../../../win.amd64/$(KBUILD_TYPE)/repack/$(notdir $(PACKAGE_NAME_MULTIARCH_COMMONCAB)) ^' ) \
+		,'  -target-all $(notdir $(PACKAGE_NAME_MULTIARCH_COMMONCAB)) ^' ) \
 		'  -stub ../bin/VBoxStub.exe || exit /b1' \
 		'$(VBOX_VCC_EDITBIN) /IntegrityCheck:NO $(@F) || exit /b1' \
@@ -1256,10 +1256,10 @@
 	$(RePackScripts_0_OUTDIR)/VMMR0.inf \
 	$(RePackScripts_0_OUTDIR)/VBoxExtPackPuel.inf
-if !defined(VBOX_WITH_COMBINED_PACKAGE) || "$(KBUILD_TARGET_ARCH)" == "x86"
+if !defined(VBOX_WITH_COMBINED_PACKAGE) || "$(KBUILD_TARGET_ARCH)" == "amd64"
  RePackScripts_SOURCES += \
  	$(RePackScripts_0_OUTDIR)/RepackExtPack.cmd
 endif
 ifdef VBOX_WITH_COMBINED_PACKAGE
- if "$(KBUILD_TARGET_ARCH)" == "x86"
+ if "$(KBUILD_TARGET_ARCH)" == "amd64"
   RePackScripts_SOURCES += \
   	$(RePackScripts_0_OUTDIR)/Combined-1-Prepare.cmd \